function registerCftGammSpin(obj, spin)
    spin.ValueChangedFcn = @(src, evt)(valueChangedCallback(obj.ndSpecGamma, src, evt));

    comg.Node.output("Set Gamma for Showing Spectrum", ...
            @(val)(setSpinValue(spin, val)), ...
            obj.ndSpecGamma ...
        ).activate();
end

function setSpinValue(spin, val)
    spin.Value = val;
end

function valueChangedCallback(ndSpecGamma, src, evt)
    fprintf('Gamma value changed from %d to %d.\n', evt.PreviousValue, evt.Value);
    ndSpecGamma.updateValue(evt.Value);
end


