function registerMaxOrdSpin(obj, spin)
    spin.ValueChangedFcn = @(src, evt)(valueChangedCallback(obj.ndSpecShowOrd, src, evt));

    comg.Node.output("Set Maximal Order for Showing Spectrum", ...
            @(val)(setSpinValue(spin, val)), ...
            obj.ndSpecShowOrd ...
        ).activate();
end

function setSpinValue(spin, val)
    spin.Value = val;
end

function valueChangedCallback(ndSpecShowOrd, src, evt)
    fprintf('Maximal Order value changed from %d to %d.\n', evt.PreviousValue, evt.Value);
    ndSpecShowOrd.updateValue(evt.Value);
end

