function registerTFEstTraceThresButton(obj, butt)
    butt.ButtonPushedFcn = @(src, evt)(buttonPushedCallback( ...
        src, evt, obj));
    
    comg.Node.output("Enable Estimate-Threshold-Button",...
            @(fila_engine, stat_free, stat_foc)(enableComponent(butt, fila_engine, stat_free, stat_foc)), ...
            obj.ndFilaEngn, obj.ndStatTFFree, obj.ndStatTFFoc ...
        ).activate();
end

function enableComponent(component, fila_engine, stat_free, stat_foc)
    flag_enable = fila_engine.inFilamentTuningMode();
    flag_enable = flag_enable && (stat_free || stat_foc);

    component.Enable = flag_enable;
end

function buttonPushedCallback(src, evt, obj)
    fprintf("Tracing Threshold Estimation Button Pressed.\n");

    vol = obj.ndTomoVol.value;
    init_pts = obj.ndTFNewFilaPts.value;
    extr_rad = ceil(obj.ndFilaOutRad.value*1.5);
    temp_rad = extr_rad;
    seg_len = 50;
    sear_step = 30;
%     sear_numb = [20,20]; % point numbers for forward and backward
%     sear_range = 7;
    sear_numb = 1; % point numbers for forward and backward
    sear_range = 1;

    [~,~,~,rand_scores] = helix.filamentTracing3Dfast(vol, init_pts, extr_rad, temp_rad,...
        seg_len, sear_step, sear_numb, sear_range, 'est_rand_scores', true, 'num_rand_scores', 100);
    threshold = prctile(rand_scores(:), 97);
    
    obj.ndTFTracThr.updateValue(threshold);

end
