function registerTFFilaTraceButton(obj, butt)
    butt.ButtonPushedFcn = @(src, evt)(buttonPushedCallback( ...
        src, evt, obj));
    
    comg.Node.output("Enable Filament-Tracing-Button",...
            @(fila_engine, stat_free, stat_foc)(enableComponent(butt, fila_engine, stat_free, stat_foc)), ...
            obj.ndFilaEngn, obj.ndStatTFFree, obj.ndStatTFFoc ...
        ).activate();
end

function enableComponent(component, fila_engine, stat_free, stat_foc)
    flag_enable = fila_engine.inFilamentTuningMode();
    flag_enable = flag_enable && (stat_free || stat_foc);

    component.Enable = flag_enable;
end

function buttonPushedCallback(src, evt, obj)
    fprintf("Filament Tracing Button Pressed.\n");

    tomo_vol = obj.ndTomoVol.value;
    init_pts = obj.ndTFNewFilaPts.value;
    extr_rad = ceil(obj.ndFilaOutRad.value*1.5);
    temp_rad = extr_rad;
    seg_len = 50;
    sear_step = 30;
    sear_numb = [5,5]; % point numbers for forward and backward
    sear_range = 7;
    score_thres = obj.ndTFTracThr.value;
    border_dist = [30,30,15];
    back_ignore_num = 0;

    [forward_traced_pts, ~, fwd_score]  = helix.filamentTracing3Dfast(tomo_vol, init_pts, extr_rad, temp_rad,...
        seg_len, sear_step, sear_numb(1), sear_range, 'score_thres', score_thres, 'border_dist', border_dist);

    bk_ini_pts = [forward_traced_pts(:,end:-1:1), init_pts(:,end:-1:1)];
    bk_ini_pts = bk_ini_pts(:,1:end-back_ignore_num);

    [backward_traced_pts, ~, bwd_score] = helix.filamentTracing3Dfast(tomo_vol, bk_ini_pts, extr_rad, temp_rad,...
        seg_len, sear_step, sear_numb(2), sear_range, 'score_thres', score_thres, 'border_dist', border_dist);

    full_fila_pts = [backward_traced_pts(:,end:-1:1), bk_ini_pts(:,end:-1:1)];
    full_scores = [bwd_score(:,end:-1:1), fwd_score(:,1+back_ignore_num:end)];

    obj.ndTFNewFilaPts.updateValue(full_fila_pts);

end

