function registerTFOptRpvButton(obj, butt)
    butt.ButtonPushedFcn = @(src, evt)(buttonPushedCallback( ...
        obj.ndSpecVa, obj.ndSpecVb, obj.ndSpecOptAng, obj.ndSpecOptLen, obj.ndTylLogSpec, src, evt));
    
    comg.Node.output("Enable Opt-Rpv-Button",...
            @(fila_engine, stat_free, stat_foc, rpvvalid)(enableComponent(butt, fila_engine, stat_free, stat_foc, rpvvalid)), ...
            obj.ndFilaEngn, obj.ndStatTFFree, obj.ndStatTFFoc, obj.ndStatRpvValid ...
        ).activate();
end

function enableComponent(component, fila_engine, stat_free, stat_foc, rpvvalid)
    flag_enable = fila_engine.inFilamentTuningMode();
    flag_enable = flag_enable && (stat_free || stat_foc);
    flag_enable = flag_enable && rpvvalid;

    component.Enable = flag_enable;
end

function buttonPushedCallback(ndSpecVa, ndSpecVb, ndSpecOptAng, ndSpecOptLen, ndTylLogSpec, src, evt)
    fprintf("TF Optimize Recip-Primitive Vectors button pushed.\n");

    sum_ind = 5;
    ang_cand = -ndSpecOptAng.value:ndSpecOptAng.value;
    len_cand = -ndSpecOptLen.value:0.1:ndSpecOptLen.value;
    [rf_rpv1,rf_rpv2] = helix.rpvLocalRefine(ndTylLogSpec.value, ndSpecVa.value, ndSpecVb.value,...
        sum_ind, ang_cand, len_cand);

    upder = ndSpecVa.updateValue(rf_rpv1(:)');
    ndSpecVb.updateValue(rf_rpv2(:)', upder);
end



