function registerTFReconButton(obj, butt)
    butt.ButtonPushedFcn = @(src, evt)(buttonPushedCallback( ...
        obj.ndExtrFilaRect.value, obj.ndHpSn.value, obj.ndHpRise.value, obj.ndHpTwist.value, ...
        obj.ndSpecSegSize.value, obj.ndSpecSegStep.value, ...
        obj.ndExtrFilaRMFr.value, obj.ndExtrFilaRMFs.value, obj.ndExtrFilaRMFt.value, src, evt));
    
    comg.Node.output("Enable Reconstruction-Button",...
            @(fila_engine, stat_free, stat_foc, rpvvalid)(enableComponent(butt, fila_engine, stat_free, stat_foc, rpvvalid)), ...
            obj.ndFilaEngn, obj.ndStatTFFree, obj.ndStatTFFoc, obj.ndStatRpvValid ...
        ).activate();
end

function enableComponent(component, fila_engine, stat_free, stat_foc, rpvvalid)
    flag_enable = fila_engine.inFilamentTuningMode();
    flag_enable = flag_enable && (stat_free || stat_foc);
    flag_enable = flag_enable && rpvvalid;

    component.Enable = flag_enable;
end


function buttonPushedCallback(extr_fila_rect, start_num, rise, twist, segsz, segst, RMFr, RMFs, RMFt, src, evt)
    fprintf("TF Reconstruction button pushed.\n");

    [filename, pathname] = uiputfile('*.mrc', 'Save Filament Positions', 'helical_avraging.mrc');
    if ~filename
        return;
    end

%     rec_vol = helix.helicalSubtomoAveraging(extr_fila_rect, start_num, rise, twist,...
%         segsz, segst, RMFr, RMFs, RMFt, [], [], [-60,60]);
%     rec_vol.saveasmrc([pathname, filename]);

    rec_vol = helix.helicalSubtomoAveraging_vol(extr_fila_rect, start_num, rise, twist,...
        segsz, segst, RMFr, RMFs, RMFt, [], [], [-60,60]);
    savemrc(rec_vol, 1, [pathname, filename]);

    fprintf("Done.\n");    
end



