function [new_fila_pts, insert_ind] = addPointToFilament(new_pt, fila_pts)
    % new_pt: 3xK
    % fila_pts: 3xN

    fila_dir = diff(fila_pts, [], 2);
    fila_dir = [fila_dir, fila_dir(:, end)];
    [~, base_ind] = min(pdist2(fila_pts', new_pt'), [], 1);
    base_dir = fila_dir(:, base_ind);

    insert_ind = base_ind + (dot(base_dir, new_pt - fila_pts(:, base_ind), 1) > 0); % inster before this index
    insert_ind = insert_ind + (0:size(new_pt, 2) - 1); % num before
    
    num_new_pts = size(new_pt, 2)+size(fila_pts, 2);
    insert_mask = zeros(1, num_new_pts, 'logical');
    insert_mask(insert_ind) = true;

    new_fila_pts = zeros(3,num_new_pts);
    new_fila_pts(:,insert_mask) = new_pt;
    new_fila_pts(:,~insert_mask) = fila_pts;
    
end