function [smoothed_points, filament_curve, filament_length, filament_points_length, RMF_r, RMF_s, RMF_t] = filamentSmoothing(points)
    if size(points, 2) < 2
        smoothed_points = [];
        return;
    end
    filament_points_length = [0,cumsum(sqrt(sum(diff(points,[],2).^2,1)))];
    filament_curve = csapi(filament_points_length, points);
    filament_length = filament_points_length(end);
    smoothed_points = fnval(filament_curve, 0:filament_length);
    [RMF_r, RMF_s, RMF_t] = calcRMF(smoothed_points, [0;0;1]);
end