function spec = segmentSpectrum(extr_surf, seg_len, step)

    extr_len = size(extr_surf, 1);
    if extr_len >= seg_len
        spec = 0;
        Nseg = floor((extr_len-seg_len) / step) + 1;
        for iseg = 1:Nseg
            stid = (iseg-1)*step+1;
            edid = stid-1+seg_len;
            spec = spec + sum(abs(cfft2(extr_surf(stid:edid,:,:))).^2,3);
        end
    else
        m = mean(extr_surf, 'all');
        extr_surf = extr_surf - m;
        expd_surf = cenrsz(extr_surf, [seg_len, size(extr_surf,2:3)]) + m;
        spec = sum(abs(cfft2(expd_surf)).^2,3);
    end
    
end