function avg_surf = surfHelicalAveraging(surf, rpv1, rpv2)

    ft_surf = cfft2(surf);
    ft_unit_y = 1 / size(ft_surf, 1);
    ft_unit_x = 1 / (2 * pi);

    msk = zeros(size(ft_surf, [1,2]));

    xlim = ([2,size(surf, 2)-1]-cenpos(size(surf, 2))) * ft_unit_x;
    ylim = ([2,size(surf, 1)-1]-cenpos(size(surf, 1))) * ft_unit_y;
    pts = helix.latticePoints(rpv1(:)./[2*pi;1], rpv2(:)./[2*pi;1], xlim, ylim, [0;0]);

    for ibx = 0:0
        for iby = 0:1
            pty = pts(2,:)/ft_unit_y;
            ptx = pts(1,:)/ft_unit_x;
            pt_ind = sub2ind(size(ft_surf, [1, 2]),...
                iby + floor(pty)+cenpos(size(surf, 1)),...
                ibx + floor(ptx)+cenpos(size(surf, 2)));
            pt_val = (1 - abs(pty - iby - floor(pty))) .* (1 - abs(ptx - ibx - floor(ptx)));
            msk(pt_ind) = pt_val;
        end
    end

    fil_ft_proj = ft_surf .* msk;
    avg_surf = real(cifft2(fil_ft_proj));

end