function q = quat_mapztov(v)
% return a quaternion whose rotmat of 'point' type will map the z-axis
% vector to direction v.

    v = normalize(v, 'norm');
    v = arrayexpand(v, [3,1]);
    if abs(v(3))>1-1e-7
        if v(3) > 0
            q = quaternion([0, 0, 0], 'rotvec');
        else
            q = quaternion([pi, 0, 0], 'rotvec');
        end
    else
        z = [0; 0; 1];
        rot_ax = normalize(cross(z, v), 'norm');
        rot_ang = atan2(norm(cross(z,v)), dot(z,v));
        q = quaternion(rot_ax' * rot_ang, 'rotvec');
    end

end