function W = generate_helix_mwcoef_q(tarsz, X, Y, Z, tilt_angle_range)
% by default, the 0 angle micrograph are imaging toward z axis. The Y-axis
% is exactly the tilting axis.

%     axis_vec = end_point - start_point;
%     axis_rotvec = cross([0,0,1], axis_vec);
%     ang = atan2(norm(axis_rotvec), dot([0,0,1], axis_vec));
%     if norm(axis_rotvec) ~= 0
%         axis_rotvec = normalize(axis_rotvec, 'norm').*ang;
%     end
%     axis_rotmat = quaternion(axis_rotvec, 'rotvec').rotmat('point');
    
    axis_rotmat = [X,Y,Z];

    [cx,cy,cz] = cencoord(tarsz);
    cx = cx / tarsz(1);
    cy = cy / tarsz(2);
    cz = cz / tarsz(3);
    rtcd = axis_rotmat * [cx(:), cy(:), cz(:)]';

    t_ang = atan2d(rtcd(3,:),-rtcd(1,:));
    t_ang(t_ang>90) = t_ang(t_ang>90) - 180;
    t_ang(t_ang<-90) = t_ang(t_ang<-90) + 180;

    W = (t_ang > tilt_angle_range(1)) .* (t_ang < tilt_angle_range(2));
    W = reshape(W, tarsz);

end